#include <windows.h>
#include "math.h"
#include "fixed.h"

#define roundf(x) floor(x + 0.5f)

void line_DDA_fixed(HDC hdc, float x1, float y1, float x2, float y2)
{
	//       , 
	//    
	int iX1 = roundf(x1);
	int iY1 = roundf(y1);
	int iX2 = roundf(x2);
	int iY2 = roundf(y2);

	//    
	int deltaX = abs(iX1 - iX2);
	int deltaY = abs(iY1 - iY2);

	//    , 
	//   .      
	// ,   
	int length = max(deltaX, deltaY);

	//  ,      
	if (length == 0)
	{
		SetPixel(hdc, iX1, iY1, 0);
		return;
	}

	//          
	fixed dX = frac_to_fixed(x2 - x1, length);
	fixed dY = frac_to_fixed(y2 - y1, length);

	//  
	fixed x = float_to_fixed(x1);
	fixed y = float_to_fixed(y1);

	//  
	length++;
	while (length--)
	{
		SetPixel(hdc, round_fixed(x), round_fixed(y), 0);
		x += dX;
		y += dY;
	}
}